#define USEGMP
#include "./bu.h"
#include "bn.h"

#include "mpf_class2.h"
#include<iostream>
#include<iomanip>

typedef const char* cstr;

int main() {
	vect_t v = VINIT_ZERO;

	std::cout << std::setprecision(10);

    //bu_log("hello vector: %lf, %lf, %lf\n", V3ARGS(v));
    std::cout << "hello vector: " << v[X] <<  ", " <<  v[Y] << ", " << v[Z] << std::endl;

	fastf_t a(1.999);
	std::cout << "1.999/13.51566=" << (a/fastf_t(13.51566)) << std::endl;
	std::cout << "1.999 + 0.023=" << (a + fastf_t(0.023)) << std::endl;
	std::cout << "1.999 - 0.0235=" << ( a - fastf_t(0.0235)) << std::endl;
	std::cout << "1.999* 13.51566=" << (a * fastf_t(13.51566)) << std::endl;
	std::cout << "1.999² = " <<( a * a )<< std::endl;
	fastf_t b = a;
	b += 3.55556;
	std::cout << "b = " << (b) << "; a = " << (a) << std::endl;
	std::cout << "double b = " << (double) b << std::endl;

	if (a < b) {
		std::cout << "Look at me! a is less than b!" << std::endl;
	}

    //vect_t v1  = {1.5,1.2,-1}, v2 = {-9,6,3.25};
    point_t v1 = {1.2,1.5,-1}, v2={-9,-3,-2};
    //bu_log("Distance between v1 and v2: %6.6f\n", bn_dist_pt3_pt3(v1, v2));
	for (unsigned char i=0; i < ELEMENTS_PER_POINT; ++i) {
		std::cout << "v1:" << v1[i] << std::endl << "v2:" << v2[i] << std::endl;
    }
    std::cout << "Distance betewen v1 and v2: " << bn_dist_pt3_pt3(v1, v2) << std::endl;

	return 0;
}
